﻿@page "/department"
@using VacationSchedule.Core.Models.DB;
@inject HttpClient Http

<PageTitle>Структура организации</PageTitle>

<h1>Структура</h1>

@if (departments == null)
{
    <p><em>Loading...</em></p>
}
else
{
    <table class="table">
        <thead>
            <tr>
                <th>Наименование</th>
                <th>Головное подразделение</th>
                <th>Руководитель</th>
                <th>Действия</th>
            </tr>
        </thead>
        <tbody>
            @foreach (var department in departments)
            {
                <tr>
                    <td>@department.DepartmentName</td>
                    <td>
                        <select class="form-control selectpicker" @bind=@getDep(department).Id>
                            <option value="-1">--select--</option>
                            @foreach (var item in departments)
                            {
                                <option value="@item.Id">@item.DepartmentName</option>
                            }
                        </select>
                    </td>
                    <td>
                        <select class="form-control selectpicker" @bind=@getUser(department).Id>
                            <option value="-1">--select--</option>
                            @foreach (var item in department.Users)
                            {
                                <option value="@item.Id">@item.LastName @item.FirstName @item.PatronymicName</option>
                            }
                        </select>
                    </td>
                    <td>
                        <button class="btn btn-primary" @onclick="@(e => SaveDep(department))">Save</button>
                    </td>
                </tr>
            }
            <tr>
                <td>
                    <input type="text" class="form-control" placeholder="Наименование подразделения" @bind="newDepartment.DepartmentName" />
                </td>
                <td>
                    <select class="form-control selectpicker" @bind=@getDep(newDepartment).Id>
                        <option value="-1">--select--</option>
                        @foreach (var item in departments)
                        {
                            <option value="@item.Id">@item.DepartmentName</option>
                        }
                    </select>
                </td>
                <td></td>
                <td>
                    <button class="btn btn-primary" @onclick="@(e => AddDep(newDepartment))">Add</button>
                </td>
            </tr>
        </tbody>
    </table>
}

@code {
    private Department[] departments;
    private User[] users;
    private Department newDepartment;

    protected override async Task OnInitializedAsync()
    {
        await RefreshDeps();
    }

    private async Task RefreshDeps()
    {
        departments = await Http.GetFromJsonAsync<Department[]>("api/Department");
        newDepartment = NewDep();
        foreach (var d in departments)
        {
            if (d.HeadOfDepartmentUser is null)
            {
                d.HeadOfDepartmentUser = new User { Id = -1 };
            }
            if (d.Parent  is null)
            {
                d.Parent = new Department { Id = -1 };
            }
            d.Users = (await Http.GetFromJsonAsync<User[]>($"api/User/GetByDepartmentId?id={d.Id}")).ToList();
        }
    }

    private User getUser(Department dep)
    {
        if (dep.HeadOfDepartmentUser is not null)
        {
            return dep.HeadOfDepartmentUser;
        }
        return new User { Id = -1 };
    }

    private Department getDep(Department dep)
    {
        if (dep.Parent is not null)
        {
            return dep.Parent;
        }
        return new Department { Id = -1 };
    }

    private async Task SaveDep(Department dep)
    {
        await Http.PutAsJsonAsync<Department>($"api/Department/{dep.Id}", dep);
    }

    private async Task AddDep(Department dep)
    {
        await Http.PostAsJsonAsync<Department>($"api/Department", dep);
        await RefreshDeps();
    }

    private Department NewDep() => new() { Parent = new Department { Id = -1, DepartmentName = "" } };
}
